com.amazonaws.services.elastictranscoder

## Interface AmazonElasticTranscoder

All Known Subinterfaces:
  AmazonElasticTranscoderAsync

All Known Implementing Classes:
  AbstractAmazonElasticTranscoder, AbstractAmazonElasticTranscoderAsync, AmazonElasticTranscoderAsyncClient, AmazonElasticTranscoderClient

    public interface AmazonElasticTranscoder

Interface for accessing Amazon Elastic Transcoder.

Note: Do not directly implement this interface, new methods are added to it regularly. Extend from `AbstractAmazonElasticTranscoder` instead.

<fullname>AWS Elastic Transcoder Service</fullname>

The AWS Elastic Transcoder Service.

### Field Summary

Fields
`static String` `ENDPOINT_PREFIX` The region metadata service name for computing region endpoints.

### Method Summary

All Methods Instance Methods Abstract Methods Deprecated Methods
`CancelJobResult` `cancelJob(CancelJobRequest cancelJobRequest)` The CancelJob operation cancels an unfinished job.
`CreateJobResult` `createJob(CreateJobRequest createJobRequest)` When you create a job, Elastic Transcoder returns JSON data that includes the values that you specified plus information about the job that is created.
`CreatePipelineResult` `createPipeline(CreatePipelineRequest createPipelineRequest)` The CreatePipeline operation creates a pipeline with settings that you specify.
`CreatePresetResult` `createPreset(CreatePresetRequest createPresetRequest)` The CreatePreset operation creates a preset with settings that you specify.
`DeletePipelineResult` `deletePipeline(DeletePipelineRequest deletePipelineRequest)` The DeletePipeline operation removes a pipeline.
`DeletePresetResult` `deletePreset(DeletePresetRequest deletePresetRequest)` The DeletePreset operation removes a preset that you've added in an AWS region.
`ResponseMetadata` `getCachedResponseMetadata(AmazonWebServiceRequest request)` Returns additional metadata for a previously executed successful request, typically used for debugging issues where a service isn't acting as expected.
`ListJobsByPipelineResult` `listJobsByPipeline(ListJobsByPipelineRequest listJobsByPipelineRequest)` The ListJobsByPipeline operation gets a list of the jobs currently in a pipeline.
`ListJobsByStatusResult` `listJobsByStatus(ListJobsByStatusRequest listJobsByStatusRequest)` The ListJobsByStatus operation gets a list of jobs that have a specified status.
`ListPipelinesResult` `listPipelines()` Simplified method form for invoking the ListPipelines operation.
`ListPipelinesResult` `listPipelines(ListPipelinesRequest listPipelinesRequest)` The ListPipelines operation gets a list of the pipelines associated with the current AWS account.
`ListPresetsResult` `listPresets()` Simplified method form for invoking the ListPresets operation.
`ListPresetsResult` `listPresets(ListPresetsRequest listPresetsRequest)` The ListPresets operation gets a list of the default presets included with Elastic Transcoder and the presets that you've added in an AWS region.
`ReadJobResult` `readJob(ReadJobRequest readJobRequest)` The ReadJob operation returns detailed information about a job.
`ReadPipelineResult` `readPipeline(ReadPipelineRequest readPipelineRequest)` The ReadPipeline operation gets detailed information about a pipeline.
`ReadPresetResult` `readPreset(ReadPresetRequest readPresetRequest)` The ReadPreset operation gets detailed information about a preset.
`void` `setEndpoint(String endpoint)` Overrides the default endpoint for this client ("elastictranscoder.us-east-1.amazonaws.com/").
`void` `setRegion(Region region)` An alternative to `setEndpoint(String)`, sets the regional endpoint for this client's service calls.
`void` `shutdown()` Shuts down this client object, releasing any resources that might be held open.
`TestRoleResult` `testRole(TestRoleRequest testRoleRequest)` Deprecated.
`UpdatePipelineResult` `updatePipeline(UpdatePipelineRequest updatePipelineRequest)` Use the `UpdatePipeline` operation to update settings for a pipeline.
`UpdatePipelineNotificationsResult` `updatePipelineNotifications(UpdatePipelineNotificationsRequest updatePipelineNotificationsRequest)` With the UpdatePipelineNotifications operation, you can update Amazon Simple Notification Service (Amazon SNS) notifications for a pipeline.
`UpdatePipelineStatusResult` `updatePipelineStatus(UpdatePipelineStatusRequest updatePipelineStatusRequest)` The UpdatePipelineStatus operation pauses or reactivates a pipeline, so that the pipeline stops or restarts the processing of jobs.
`AmazonElasticTranscoderWaiters` `waiters()`

### Field Detail

#### ENDPOINT_PREFIX

    static final String ENDPOINT_PREFIX

The region metadata service name for computing region endpoints. You can use this value to retrieve metadata (such as supported regions) of the service.

See Also:
  `RegionUtils.getRegionsForService(String)`, Constant Field Values

### Method Detail

#### setEndpoint

    void setEndpoint(String endpoint)

Overrides the default endpoint for this client ("elastictranscoder.us-east-1.amazonaws.com/"). Callers can use this method to control which AWS region they want to work with.

Callers can pass in just the endpoint (ex: "elastictranscoder.us-east-1.amazonaws.com/") or a full URL, including the protocol (ex: "elastictranscoder.us-east-1.amazonaws.com/"). If the protocol is not specified here, the default protocol from this client's `ClientConfiguration` will be used, which by default is HTTPS.

For more information on using AWS regions with the AWS SDK for Java, and a complete list of all available endpoints for all AWS services, see: http://developer.amazonwebservices.com/connect/entry.jspa?externalID=3912

This method is not threadsafe. An endpoint should be configured when the client is created and before any service requests are made. Changing it afterwards creates inevitable race conditions for any service requests in transit or retrying.

Parameters:
  `endpoint` - The endpoint (ex: "elastictranscoder.us-east-1.amazonaws.com/") or a full URL, including the protocol (ex: "elastictranscoder.us-east-1.amazonaws.com/") of the region specific AWS endpoint this client will communicate with.

#### setRegion

    void setRegion(Region region)

An alternative to `setEndpoint(String)`, sets the regional endpoint for this client's service calls. Callers can use this method to control which AWS region they want to work with.

By default, all service endpoints in all regions use the https protocol. To use http instead, specify it in the `ClientConfiguration` supplied at construction.

This method is not threadsafe. A region should be configured when the client is created and before any service requests are made. Changing it afterwards creates inevitable race conditions for any service requests in transit or retrying.

Parameters:
  `region` - The region this client will communicate with. See `Region.getRegion(com.amazonaws.regions.Regions)` for accessing a given region. Must not be null and must be a region where the service is available.
See Also:
  `Region.getRegion(com.amazonaws.regions.Regions)`, `Region.createClient(Class, com.amazonaws.auth.AWSCredentialsProvider, ClientConfiguration)`, `Region.isServiceSupported(String)`

#### cancelJob

    CancelJobResult cancelJob(CancelJobRequest cancelJobRequest)

The CancelJob operation cancels an unfinished job.

<note>

You can only cancel a job that has a status of `Submitted`. To prevent a pipeline from starting to process a job while you're getting the job identifier, use UpdatePipelineStatus to temporarily pause the pipeline.

</note>

Parameters:
  `cancelJobRequest` - The `CancelJobRequest` structure.
Returns:
  Result of the CancelJob operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `ResourceInUseException` - The resource you are attempting to change is in use. For example, you are attempting to delete a pipeline that is currently in use.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### createJob

    CreateJobResult createJob(CreateJobRequest createJobRequest)

When you create a job, Elastic Transcoder returns JSON data that includes the values that you specified plus information about the job that is created.

If you have specified more than one output for your jobs (for example, one output for the Kindle Fire and another output for the Apple iPhone 4s), you currently must use the Elastic Transcoder API to list the jobs (as opposed to the AWS Console).

Parameters:
  `createJobRequest` - The `CreateJobRequest` structure.
Returns:
  Result of the CreateJob operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `LimitExceededException` - Too many operations for a given AWS account. For example, the number of pipelines exceeds the maximum allowed.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### createPipeline

    CreatePipelineResult createPipeline(CreatePipelineRequest createPipelineRequest)

The CreatePipeline operation creates a pipeline with settings that you specify.

Parameters:
  `createPipelineRequest` - The `CreatePipelineRequest` structure.
Returns:
  Result of the CreatePipeline operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `LimitExceededException` - Too many operations for a given AWS account. For example, the number of pipelines exceeds the maximum allowed.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### createPreset

    CreatePresetResult createPreset(CreatePresetRequest createPresetRequest)

The CreatePreset operation creates a preset with settings that you specify.

<important>

Elastic Transcoder checks the CreatePreset settings to ensure that they meet Elastic Transcoder requirements and to determine whether they comply with H.264 standards. If your settings are not valid for Elastic Transcoder, Elastic Transcoder returns an HTTP 400 response (`ValidationException`) and does not create the preset. If the settings are valid for Elastic Transcoder but aren't strictly compliant with the H.264 standard, Elastic Transcoder creates the preset and returns a warning message in the response. This helps you determine whether your settings comply with the H.264 standard while giving you greater flexibility with respect to the video that Elastic Transcoder produces.

</important>

Elastic Transcoder uses the H.264 video-compression format. For more information, see the International Telecommunication Union publication Recommendation ITU-T H.264: Advanced video coding for generic audiovisual services.

Parameters:
  `createPresetRequest` - The `CreatePresetRequest` structure.
Returns:
  Result of the CreatePreset operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `LimitExceededException` - Too many operations for a given AWS account. For example, the number of pipelines exceeds the maximum allowed.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### deletePipeline

    DeletePipelineResult deletePipeline(DeletePipelineRequest deletePipelineRequest)

The DeletePipeline operation removes a pipeline.

You can only delete a pipeline that has never been used or that is not currently in use (doesn't contain any active jobs). If the pipeline is currently in use, `DeletePipeline` returns an error.

Parameters:
  `deletePipelineRequest` - The `DeletePipelineRequest` structure.
Returns:
  Result of the DeletePipeline operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `ResourceInUseException` - The resource you are attempting to change is in use. For example, you are attempting to delete a pipeline that is currently in use.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### deletePreset

    DeletePresetResult deletePreset(DeletePresetRequest deletePresetRequest)

The DeletePreset operation removes a preset that you've added in an AWS region.

<note>

You can't delete the default presets that are included with Elastic Transcoder.

</note>

Parameters:
  `deletePresetRequest` - The `DeletePresetRequest` structure.
Returns:
  Result of the DeletePreset operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### listJobsByPipeline

    ListJobsByPipelineResult listJobsByPipeline(ListJobsByPipelineRequest listJobsByPipelineRequest)

The ListJobsByPipeline operation gets a list of the jobs currently in a pipeline.

Elastic Transcoder returns all of the jobs currently in the specified pipeline. The response body contains one element for each job that satisfies the search criteria.

Parameters:
  `listJobsByPipelineRequest` - The `ListJobsByPipelineRequest` structure.
Returns:
  Result of the ListJobsByPipeline operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### listJobsByStatus

    ListJobsByStatusResult listJobsByStatus(ListJobsByStatusRequest listJobsByStatusRequest)

The ListJobsByStatus operation gets a list of jobs that have a specified status. The response body contains one element for each job that satisfies the search criteria.

Parameters:
  `listJobsByStatusRequest` - The `ListJobsByStatusRequest` structure.
Returns:
  Result of the ListJobsByStatus operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### listPipelines

    ListPipelinesResult listPipelines(ListPipelinesRequest listPipelinesRequest)

The ListPipelines operation gets a list of the pipelines associated with the current AWS account.

Parameters:
  `listPipelinesRequest` - The `ListPipelineRequest` structure.
Returns:
  Result of the ListPipelines operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### listPipelines

    ListPipelinesResult listPipelines()

Simplified method form for invoking the ListPipelines operation.

See Also:
  `listPipelines(ListPipelinesRequest)`

#### listPresets

    ListPresetsResult listPresets(ListPresetsRequest listPresetsRequest)

The ListPresets operation gets a list of the default presets included with Elastic Transcoder and the presets that you've added in an AWS region.

Parameters:
  `listPresetsRequest` - The `ListPresetsRequest` structure.
Returns:
  Result of the ListPresets operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### listPresets

    ListPresetsResult listPresets()

Simplified method form for invoking the ListPresets operation.

See Also:
  `listPresets(ListPresetsRequest)`

#### readJob

    ReadJobResult readJob(ReadJobRequest readJobRequest)

The ReadJob operation returns detailed information about a job.

Parameters:
  `readJobRequest` - The `ReadJobRequest` structure.
Returns:
  Result of the ReadJob operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### readPipeline

    ReadPipelineResult readPipeline(ReadPipelineRequest readPipelineRequest)

The ReadPipeline operation gets detailed information about a pipeline.

Parameters:
  `readPipelineRequest` - The `ReadPipelineRequest` structure.
Returns:
  Result of the ReadPipeline operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### readPreset

    ReadPresetResult readPreset(ReadPresetRequest readPresetRequest)

The ReadPreset operation gets detailed information about a preset.

Parameters:
  `readPresetRequest` - The `ReadPresetRequest` structure.
Returns:
  Result of the ReadPreset operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### testRole

    @Deprecated
    TestRoleResult testRole(TestRoleRequest testRoleRequest)

Deprecated.

The TestRole operation tests the IAM role used to create the pipeline.

The `TestRole` action lets you determine whether the IAM role you are using has sufficient permissions to let Elastic Transcoder perform tasks associated with the transcoding process. The action attempts to assume the specified IAM role, checks read access to the input and output buckets, and tries to send a test notification to Amazon SNS topics that you specify.

Parameters:
  `testRoleRequest` - The `TestRoleRequest` structure.
Returns:
  Result of the TestRole operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### updatePipeline

    UpdatePipelineResult updatePipeline(UpdatePipelineRequest updatePipelineRequest)

Use the `UpdatePipeline` operation to update settings for a pipeline.

<important>

When you change pipeline settings, your changes take effect immediately. Jobs that you have already submitted and that Elastic Transcoder has not started to process are affected in addition to jobs that you submit after you change settings.

</important>

Parameters:
  `updatePipelineRequest` - The `UpdatePipelineRequest` structure.
Returns:
  Result of the UpdatePipeline operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `ResourceInUseException` - The resource you are attempting to change is in use. For example, you are attempting to delete a pipeline that is currently in use.
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### updatePipelineNotifications

    UpdatePipelineNotificationsResult updatePipelineNotifications(UpdatePipelineNotificationsRequest updatePipelineNotificationsRequest)

With the UpdatePipelineNotifications operation, you can update Amazon Simple Notification Service (Amazon SNS) notifications for a pipeline.

When you update notifications for a pipeline, Elastic Transcoder returns the values that you specified in the request.

Parameters:
  `updatePipelineNotificationsRequest` - The `UpdatePipelineNotificationsRequest` structure.
Returns:
  Result of the UpdatePipelineNotifications operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `ResourceInUseException` - The resource you are attempting to change is in use. For example, you are attempting to delete a pipeline that is currently in use.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### updatePipelineStatus

    UpdatePipelineStatusResult updatePipelineStatus(UpdatePipelineStatusRequest updatePipelineStatusRequest)

The UpdatePipelineStatus operation pauses or reactivates a pipeline, so that the pipeline stops or restarts the processing of jobs.

Changing the pipeline status is useful if you want to cancel one or more jobs. You can't cancel jobs after Elastic Transcoder has started processing them; if you pause the pipeline to which you submitted the jobs, you have more time to get the job IDs for the jobs that you want to cancel, and to send a CancelJob request.

Parameters:
  `updatePipelineStatusRequest` - The `UpdatePipelineStatusRequest` structure.
Returns:
  Result of the UpdatePipelineStatus operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `ResourceInUseException` - The resource you are attempting to change is in use. For example, you are attempting to delete a pipeline that is currently in use.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### shutdown

    void shutdown()

Shuts down this client object, releasing any resources that might be held open. This is an optional method, and callers are not expected to call it, but can if they want to explicitly release any open resources. Once a client has been shutdown, it should not be used to make any more requests.

#### getCachedResponseMetadata

    ResponseMetadata getCachedResponseMetadata(AmazonWebServiceRequest request)

Returns additional metadata for a previously executed successful request, typically used for debugging issues where a service isn't acting as expected. This data isn't considered part of the result data returned by an operation, so it's available through this separate, diagnostic interface.

Response metadata is only cached for a limited period of time, so if you need to access this extra diagnostic information for an executed request, you should use this method to retrieve it as soon as possible after executing a request.

Parameters:
  `request` - The originally executed request.
Returns:
  The response metadata for the specified request, or null if none is available.

#### waiters

    AmazonElasticTranscoderWaiters waiters()